// wtimer.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include "io.h"
#include <stdio.h>
int wait1us(int);
void outportb(USHORT,BYTE);
UCHAR inportb(USHORT);
UCHAR* pSign(UCHAR *);
UCHAR* pErase(void);
UCHAR sendbyte(UCHAR,UCHAR);
UCHAR glock(UCHAR);

#define pardata 0x378
#define parstat 0x379
#define parinst 0x37A

int GL_w;
int	GL_flsz=0x400;	// flash size in bytes (default =1k)
int	GL_ha;			// high part of address

int goin(void)
{
//  +5  
	outportb(pardata,0x10);
//printf("+5 reset\n");
//getchar();
	wait1us(1000);
//  0   - . 
	outportb(pardata,0x20);
//printf("0v reset\n");
//getchar();
	wait1us(1);
// 4   clock
	outportb(parinst, 0xCC);
	wait1us(1);
	outportb(parinst, 0xCD);
	wait1us(1);
	outportb(parinst, 0xCC);
	wait1us(1);
	outportb(parinst, 0xCD);
	wait1us(1);
	outportb(parinst, 0xCC);
	wait1us(1);
	outportb(parinst, 0xCD);
	wait1us(1);
	outportb(parinst, 0xCC);
	wait1us(1);
	outportb(parinst, 0xCD);
	wait1us(1);
//  +12  reset
	outportb(pardata,0x00);
//printf("+12v reset\n");
//getchar();
	wait1us(1);
	outportb(pardata,0x01);
	Sleep(1);
	return 0;
}

UCHAR* rFuse(UCHAR *b)
{
	sendbyte(4,0x4C);
	sendbyte(0,0x68);
	b[0]=sendbyte(0,0x6C);
	b[1]=0;
	return b;
}
UCHAR wFuse(UCHAR b)
{
	sendbyte(0x40,0x4C);
	sendbyte(b,0x2C);
	sendbyte(0,0x64);
	sendbyte(0,0x6C);
	return 0;
}

USHORT rWord(USHORT addr)
{
	UCHAR hiadr,tmp;
	USHORT out;
//    :

	hiadr=(addr&0x100)>>8;
	sendbyte(hiadr,0x1C);
	sendbyte(addr&0xFF,0x0C);
//   
	sendbyte(0,0x68);
	tmp=sendbyte(0,0x6C);
//   
	sendbyte(0,0x78);
	out=tmp|(sendbyte(0,0x7C)<<8);
	return out;
}

USHORT wWord(USHORT *b,USHORT a)
{
	UCHAR hiadr,hi,lo,tmp;

//    !:

	lo=UCHAR(b[a]&0xFF);
	hi=UCHAR(b[a]>>8);

	hiadr=(a&0x100)>>8;
	if(hiadr!=GL_ha) {sendbyte(hiadr,0x1C); GL_ha=hiadr;}
	sendbyte(a&0xFF,0x0C);
	if(b[a]==0xFFFF) return 0;
printf("[%02X;%02X]",a&0xFF,0xC);
//   
//	if(lo!=0xFF){
		sendbyte(lo,0x2C);
printf("[%02X!%02X]",lo,0x2c);
		sendbyte(0,0x64);
printf("[%02X;%02X]",0,0x64);
		tmp=sendbyte(0,0x6C);
printf("[%02X;%02X]",0,0x6C);
//printf("tmpa:%02X ",tmp);
		do{
		}while(!(inportb(parstat)&0x40));

//	}
//   
//	if(hi!=0xFF){
		sendbyte(hi,0x3C);
printf("[%02X!%02X]",hi,0x3c);
		sendbyte(0,0x74);
printf("[%02X;%02X]",0,0x74);
		tmp=sendbyte(0,0x7C);
printf("[%02X;%02X]\n",0,0x7C);
		do{
		}while(!(inportb(parstat)&0x40));
//	}
	return 1;
}

UCHAR *rFlash(UCHAR *buf)
{
	USHORT addr,i;
	char *z="-\\|/";

	sendbyte(2,0x4C);
	for(addr=0;addr<512;addr++)
	{
		((USHORT *)buf)[addr]=rWord(addr);
		printf("\010%c",z[i%4]);
		i++;
	}
	printf("\010");
	return buf;
}

int wFlash(UCHAR *buf,UINT n)
{
	USHORT addr,i;
	char *z="-\\|/";
	i=0;
	GL_ha=0;
	sendbyte(0x10,0x4C);
	sendbyte(0,0x1C);
	for(addr=0;addr<(n+1)/2;addr++)
	{
		wWord((USHORT *)buf,addr);
//		printf("\010%c",z[addr%4]);
//		Sleep(1);
	}
	printf("\010");
	return 0;
}
UCHAR rCal(void)
{
	sendbyte(0x8,0x4C);
	sendbyte(0,0xC);
	sendbyte(0,0x78);
	return sendbyte(0,0x7C);
}
UCHAR rLock(void)
{
	sendbyte(0x4,0x4C);
	sendbyte(0,0x78);
	return sendbyte(0,0x7C)&0x6;
}
UCHAR wLock(UCHAR lock)
{
	sendbyte(0x20,0x4C);
	sendbyte(lock,0x2C);
	sendbyte(0,0x64);
	sendbyte(0,0x6C);
	do{
	}while(!(inportb(parstat)&0x40));
	return	1;
}

int main(int argc,char *argv[])
{
	LARGE_INTEGER qt;
	UCHAR sign[4];
	UCHAR fuse[2];
	UCHAR *fl;
	char st[256];
	OSVERSIONINFO osinfo;
	int	c;

	osinfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osinfo);
	if(osinfo.dwPlatformId==VER_PLATFORM_WIN32_NT){
		if(InitIO()) { puts("error loading giveio.sys driver"); exit(-1);}
	}
	printf("AquaSoft ATTiny high-voltage programmer version 0.0\n");

	QueryPerformanceFrequency(&qt);
	GL_w=(int)qt.QuadPart;
	GL_w=GL_w/1000000+1;
//  ,  
	outportb(parinst, 0xCD);
	outportb(pardata,0x30);
	printf("Insert adapter card, turn ON and press enter...\n");
	getchar();
	goin();	//   ..  
// 
	pSign(sign);
	printf("Signature received:%02X %02X %02X\n",sign[0],sign[1],sign[2]);
	if(sign[0]==0x1E)
		if(sign[1]==0x90)
			if(sign[2]==4) printf("Attiny11 detected!\n");
			else if(sign[2]==5) {
				printf("Attiny12 detected!\n");
				printf("Calibtation byte is %02X\n",rCal());
			}
				else printf("Unknown Atmel attiny chip detected!\n");
		else printf("Unknown Atmel chip detected!\n");
	else printf("Protected chip or bad contact\n");
// GL_flsz    !
	fl=(UCHAR *)malloc(GL_flsz);
	rFuse(fuse);
	printf("Fuses received:%02X\n",fuse[0]);
    printf("(R)ead/(W)rite/(E)rase/write (F)use?");
	c=getchar();
	if((c=='e')||(c=='E')) {
		printf("Erasing");
		pErase();
		wait1us(33000);
		printf("Finished.\n");
	}
	if((c=='f')||(c=='F')) {
		printf("Writing fuses\n");
		wFuse(0x52);
		wait1us(100);
		printf("Finished.\n");
	}
	if((c=='w')||(c=='W')){
		char	*fn,*st,sbuf[100];
		FILE	*fp;
		int		ln,ii,m,xb;

		fn=(char *)malloc(256);
		for(ii=0;ii<GL_flsz;ii++) fl[ii]=0xFF;
		printf("Filename:");
		scanf("%s",fn);
		m=0;					//   
		fp=fopen(fn,"r");
		if(!fp) {puts("wrong filename!"); exit(-2);}
		ln=0;
		while(fgets(sbuf,sizeof(sbuf),fp)){
			st=&sbuf[0];
			if(sscanf(st,":%2X",&ln)&&ln>0){
				st+=3;
				sscanf(st,"%4X",&m);
				st+=4;
				for(ii=0;ii<ln;ii++){
					st+=2;
					sscanf(st,"%2X",&xb);
					fl[m++]=(UCHAR)xb;
				}
			}
		}
		fclose(fp);
		free(fn);
//   
//   
		printf("\nWriting flash: ");
		wFlash(fl,GL_flsz);
		printf("\n");

	}
	if((c=='r')||(c=='R')){
		char	*fn;
		FILE	*fp;

		fn=(char *)malloc(256);
		printf("Filename:");
		scanf("%s",fn);
		fp=fopen(fn,"wb");
		if(!fp) {printf("Error in file name!\n"); exit(-1);}
		printf("Reading: ");
		rFlash(fl);
		for(c=0;c<1024;c++){
			char dg[10];
			UCHAR sm;
			if(!((c)%16)) {sprintf(st,":10%04X00",c); sm=0x10+(c&0xFF)+(c>>8);}
			sprintf(dg,"%02X",fl[c]); sm+=fl[c];
			lstrcat(st,dg);
			if(!((c+1)%16)) {
				sm--;
				sm=~sm;
				sprintf(dg,"%02X\r\n",sm);
				lstrcat(st,dg);
				fputs(st,fp);
			}
		}
		free(fn);
		fclose(fp);
	}
	pSign(sign);
	if(sign[0]==0x1E)
		if(sign[1]==0x90)
			if(sign[2]==4) printf("Attiny11 detected!\n");
			else if(sign[2]==5) printf("Attiny12 detected!\n");
				else printf("Unknown Atmel attiny chip detected!\n");
		else printf("Unknown Atmel chip detected!\n");
	else printf("Protected chip or bad contact\n");
	if(osinfo.dwPlatformId==VER_PLATFORM_WIN32_NT) RemoveIO();
	free(fl);
	return 0;
}

int wait1us(int us)
{

	UINT s;
	LARGE_INTEGER liDueTime,qe;

	QueryPerformanceCounter(&liDueTime);
	do{
		QueryPerformanceCounter(&qe);
		s=(UINT)(qe.QuadPart-liDueTime.QuadPart);
	}while(s<(unsigned)GL_w*us);
	return 0;
}

void outportb(USHORT dport,BYTE zbt)
{
//printf("%03X:%02X\n",dport,zbt);
	_asm {
		mov		dx,dport
		mov		al,zbt
		out		dx,al
	}
}
UCHAR inportb(USHORT dport)
{
	UCHAR	rez;
	_asm {
		mov		dx,dport
		in		al,dx
		mov		rez,al
	}
//printf("%02X ",rez);
	return rez;
}

UCHAR* pSign(UCHAR *b)
{
  sendbyte(8,0x4C);
  sendbyte(0,0xC);
  sendbyte(0,0x68);
  b[0]=sendbyte(0,0x6C);

  sendbyte(1,0xC);
  sendbyte(0,0x68);
  b[1]=sendbyte(0,0x6C);

  sendbyte(2,0xC);
  sendbyte(0,0x68);
  b[2]=sendbyte(0,0x6C);

  b[3]=0;
// 1e 90 04 - tiny11
// 1e 90 05 - tiny12
 return b;
}

UCHAR sendbyte(UCHAR a,UCHAR b)
{
	UCHAR x,y,z;
	USHORT sh;
	x=0x80;
	glock(0);
	sh=0;
	while(x){
		z=a&x;
		(z)? z=1:z=0;
		y=b&x;
		(y)? y=2:y=0;
		z|=y;
		sh=(sh<<1)|glock(z);
		x>>=1;
	}

//	out=sh>>1;
//printf("%02X ",out);
	glock(0);
	glock(0);
	return (UCHAR)sh;
}

UCHAR glock(UCHAR tst)
{
	UCHAR	ae;

	ae=(inportb(parstat)&0x40);
	ae>>=6;
	outportb(pardata, tst);
	wait1us(1);
	outportb(parinst, 0xCC);
	wait1us(10);
	outportb(parinst, 0xCD);
	wait1us(10);
//printf("%02X ",ae);
	return ae;
}

UCHAR* pErase(void)
{
//	UCHAR ae;
	sendbyte(0x80,0x4C);
printf(".");
	sendbyte(0,0x64);
printf(".");
	sendbyte(0,0x6C);
printf(".");
	sendbyte(0,0x4C);
//	do{
//		ae=(inportb(parstat)&0x40);
//	}while(ae);

printf(".\n");
	return NULL;
}
