#include "stdafx.h"
#include <windows.h>
#include <stdio.h>

int	GL_te=0;
int	GL_vrem;
int	GL_act=0;

DWORD DriverInstall(SC_HANDLE hSCMan,LPSTR lpPath, LPSTR lpDriver)
{
   BOOL dwStatus = 0;
   SC_HANDLE hService = NULL;

   // add to service control manager's database
   if ((hService = CreateService(hSCMan, lpDriver, 
      "direct i/o port access driver", SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER,
      SERVICE_DEMAND_START, SERVICE_ERROR_NORMAL, lpPath, 
      NULL, NULL, NULL, NULL, NULL)) == NULL)
         dwStatus = GetLastError();
   else CloseServiceHandle(hService);

   return dwStatus;
} // DriverInstall

DWORD DriverStart(SC_HANDLE hSCMan,LPSTR lpDriver)
{
   BOOL dwStatus = 0;
   SC_HANDLE hService = NULL;

   if ((hService = OpenService(hSCMan, lpDriver,SERVICE_ALL_ACCESS)) != NULL) 
   {
      if (!StartService(hService, 0, NULL))
         dwStatus = GetLastError();
   } else dwStatus = GetLastError();
   if (hService != NULL) CloseServiceHandle(hService);
   return dwStatus;
} // DriverStart

DWORD DriverStop(SC_HANDLE hSCMan,LPSTR lpDriver)
{
   BOOL dwStatus = 0;
   SC_HANDLE hService = NULL;
   SERVICE_STATUS serviceStatus;

   if ((hService = OpenService(hSCMan, lpDriver, 
      SERVICE_ALL_ACCESS)) != NULL) 
   {
      if (!ControlService(hService, SERVICE_CONTROL_STOP,
         &serviceStatus))
            dwStatus = GetLastError();
   } else dwStatus = GetLastError();
   if (hService != NULL) CloseServiceHandle(hService);
   return dwStatus;
} // DriverStop


DWORD DriverRemove(SC_HANDLE hSCMan,LPSTR lpDriver)
{
   BOOL dwStatus = 0;
   SC_HANDLE hService = NULL;

   if ((hService = OpenService(hSCMan, lpDriver, 
      SERVICE_ALL_ACCESS)) != NULL) 
   {
      if (!DeleteService(hService))
         dwStatus = GetLastError();
   } else dwStatus = GetLastError();

   if (hService != NULL) CloseServiceHandle(hService);
   return dwStatus;
} // DriverRemove

int	InitIO(void)
{
	int	dwStatus;
	SC_HANDLE	hService,hSCMan;
	HANDLE		hFile;
	#ifdef	ERRMSG
	char		*errt="Error:";
	#endif
	#ifdef SUCCMSG
	char		*noerr="Success:";
	#endif
	char		*sname="giveio";
	char		*ext=".sys";
	char		FullPath[256];

	GetCurrentDirectory(256,FullPath);
	lstrcat(FullPath,"\\");
	lstrcat(FullPath,sname);
	lstrcat(FullPath,ext);
	hSCMan=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(!hSCMan){
#ifdef	ERRMSG
		char *bb="Can't connect to service control manager";
	#ifdef	_CONSOLE
		puts(bb);
	#else
		MessageBox(0,bb,errt,MB_OK+MB_ICONSTOP);
	#endif
#endif
		return	GetLastError();	//  
	}
    else
	{
#ifdef SUCCMSG
		char *bb="Connected to service control manager";
	#ifdef	_CONSOLE
		puts(bb);
	#else
		MessageBox(0,bb,noerr,MB_OK);
	#endif
#endif
	}
	dwStatus=0;
	hService=0;
	hService=OpenService(hSCMan,sname,SERVICE_ALL_ACCESS);
	if(!hService) {
		dwStatus=GetLastError();
		if(dwStatus==ERROR_SERVICE_DOES_NOT_EXIST) {
			dwStatus=DriverInstall(hSCMan,FullPath,sname);
			if(dwStatus) return dwStatus;
			else{
				hService=OpenService(hSCMan,sname,SERVICE_ALL_ACCESS);
				if(!hService) return GetLastError();
			}
		}
	}
	dwStatus=DriverStart(hSCMan,sname);
	if(dwStatus==2) {
#ifdef	ERRMSG
		char *bb="Driver file not found!";
	#ifndef _CONSOLE
		MessageBox(0,bb,errt,MB_OK);
	#else
		puts(bb);
	#endif
#endif
		DriverRemove(hSCMan,sname);
		return 2;
	}
	CloseServiceHandle(hSCMan);
	lstrcpy(FullPath,"\\\\.\\");
	lstrcat(FullPath,sname);
	hFile=CreateFile(FullPath,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE) {
#ifdef	ERRMSG
		char *bb="Can't create device!";
	#ifndef _CONSOLE
		MessageBox(0,bb,errt,MB_OK);
	#else
		puts(bb);
	#endif
#endif
	}
    else {
#ifdef	SUCCMSG
		char *bb="Device created";
	#ifndef _CONSOLE
		MessageBox(0,bb,noerr,MB_OK+MB_ICONINFORMATION);
	#else
		puts(bb);
	#endif
#endif
		CloseHandle(hFile);
	}
	if(hFile) dwStatus=0;
	return dwStatus;
}

int	RemoveIO(void)
{
	char		*sname="giveio";
#ifdef	ERRMSG
	char		*errt="Error:";
#endif
#ifdef SUCCMSG
	char		*noerr="Success:";
#endif
	int	dwStatus;
	SC_HANDLE	hSCMan;

	hSCMan=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(!hSCMan){
#ifdef	ERRMSG
		char *bb="Can't connect to service control manager";
	#ifndef _CONSOLE
		MessageBox(0,bb,errt,MB_OK+MB_ICONSTOP);
	#else
		puts(bb);
	#endif
#endif
		return	GetLastError();
	}
    else
	{
#ifdef SUCCMSG
		char *bb="Connected to service control manager";
	#ifndef _CONSOLE
		MessageBox(0,bb,noerr,MB_OK);
	#else
		puts(bb);
	#endif
#endif
	}
	dwStatus=DriverStop(hSCMan,sname);
	if(!dwStatus) {
#ifdef SUCCMSG
		char *bb="Driver stopped";
	#ifndef _CONSOLE
		MessageBox(0,bb,noerr,MB_OK);
	#else
		puts(bb);
	#endif
#endif
	}
	else {
		if(dwStatus==ERROR_SERVICE_NOT_ACTIVE) dwStatus=0;
		else {
#ifdef	ERRMSG
			char *bb="Can't stop driver";
	#ifndef _CONSOLE
			MessageBox(0,bb,errt,MB_OK+MB_ICONSTOP);
	#else
			puts(bb);
	#endif
#endif
			return	dwStatus;
		}
	}
	dwStatus=DriverRemove(hSCMan,sname);
	if(dwStatus){
#ifdef	ERRMSG
		char *bb="Can't remove driver.";
	#ifndef _CONSOLE
		MessageBox(0,bb,errt,MB_OK+MB_ICONSTOP);
	#else
		puts(bb);
	#endif
#endif
		return	GetLastError();
	}
    else
	{
#ifdef SUCCMSG
		char *bb="Driver removed.";
#ifndef _CONSOLE
		MessageBox(0,bb,noerr,MB_OK);
#else
		puts(bb);
#endif
#endif
	}
	CloseServiceHandle(hSCMan);
	return dwStatus;
}//	RemoveIO

